// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/in-toto/archivista/ent/attestationpolicy"
	"github.com/in-toto/archivista/ent/predicate"
)

// AttestationPolicyDelete is the builder for deleting a AttestationPolicy entity.
type AttestationPolicyDelete struct {
	config
	hooks    []Hook
	mutation *AttestationPolicyMutation
}

// Where appends a list predicates to the AttestationPolicyDelete builder.
func (apd *AttestationPolicyDelete) Where(ps ...predicate.AttestationPolicy) *AttestationPolicyDelete {
	apd.mutation.Where(ps...)
	return apd
}

// Exec executes the deletion query and returns how many vertices were deleted.
func (apd *AttestationPolicyDelete) Exec(ctx context.Context) (int, error) {
	return withHooks(ctx, apd.sqlExec, apd.mutation, apd.hooks)
}

// ExecX is like Exec, but panics if an error occurs.
func (apd *AttestationPolicyDelete) ExecX(ctx context.Context) int {
	n, err := apd.Exec(ctx)
	if err != nil {
		panic(err)
	}
	return n
}

func (apd *AttestationPolicyDelete) sqlExec(ctx context.Context) (int, error) {
	_spec := sqlgraph.NewDeleteSpec(attestationpolicy.Table, sqlgraph.NewFieldSpec(attestationpolicy.FieldID, field.TypeUUID))
	if ps := apd.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	affected, err := sqlgraph.DeleteNodes(ctx, apd.driver, _spec)
	if err != nil && sqlgraph.IsConstraintError(err) {
		err = &ConstraintError{msg: err.Error(), wrap: err}
	}
	apd.mutation.done = true
	return affected, err
}

// AttestationPolicyDeleteOne is the builder for deleting a single AttestationPolicy entity.
type AttestationPolicyDeleteOne struct {
	apd *AttestationPolicyDelete
}

// Where appends a list predicates to the AttestationPolicyDelete builder.
func (apdo *AttestationPolicyDeleteOne) Where(ps ...predicate.AttestationPolicy) *AttestationPolicyDeleteOne {
	apdo.apd.mutation.Where(ps...)
	return apdo
}

// Exec executes the deletion query.
func (apdo *AttestationPolicyDeleteOne) Exec(ctx context.Context) error {
	n, err := apdo.apd.Exec(ctx)
	switch {
	case err != nil:
		return err
	case n == 0:
		return &NotFoundError{attestationpolicy.Label}
	default:
		return nil
	}
}

// ExecX is like Exec, but panics if an error occurs.
func (apdo *AttestationPolicyDeleteOne) ExecX(ctx context.Context) {
	if err := apdo.Exec(ctx); err != nil {
		panic(err)
	}
}
